<!-- <!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>KNN Prediction Form</title>
    <link rel="stylesheet" href="../static/index.css" />
  </head>
  <body>
    <div
      id="section3"
      class="section section-custom-form section-custom-kmeans"
      style="display: flex; flex-direction: column; align-items: center"
    >
      <a
        style="
          text-decoration: none;
          color: #fefefe;
          font-size: 20px;
          display: block;
          margin-left: 80%;
        "
        href="/"
        >Back</a
      >
      <div class="container1">
        <h1>KNN</h1>
        <form id="phoneForm">
          <label for="Brand">Brand:</label>
          <input type="text" id="Brand" name="Brand" required />
          <label for="Price">Price:</label>
          <input type="number" id="Price" name="Price" required />
          <label for="Internal storage (GB)">Internal Storage (GB):</label>
          <input
            type="number"
            id="Internal storage (GB)"
            name="Internal storage (GB)"
            required
          />
          <label for="RAM (GB)">RAM (GB):</label>
          <input type="number" id="RAM (GB)" name="RAM (GB)" required />
          <label for="Rear camera">Rear Camera (MP):</label>
          <input type="number" id="Rear camera" name="Rear camera" required />
          <label for="Front camera">Front Camera (MP):</label>
          <input type="number" id="Front camera" name="Front camera" required />
          <label for="Battery capacity (mAh)">Battery Capacity (mAh):</label>
          <input
            type="number"
            id="Battery capacity (mAh)"
            name="Battery capacity (mAh)"
            required
          />
          <button type="submit">Recommend</button>
        </form>
        <div id="result"></div>
      </div>
    </div>

    <script>
      document
        .getElementById("phoneForm")
        .addEventListener("submit", function (event) {
          event.preventDefault();

          var form = document.getElementById("phoneForm");
          var formData = new FormData(form);

          var xhr = new XMLHttpRequest();
          xhr.open("POST", "/knn_predict", true);
          xhr.onload = function () {
            if (xhr.status === 200) {
              var response = JSON.parse(xhr.responseText);
              document.getElementById("result").innerHTML =
                "Recommended Phone: " + response.prediction;
            } else {
              document.getElementById("result").innerHTML =
                "Error: " + xhr.responseText;
            }
          };
          xhr.send(formData);
        });
    </script>
  </body>
</html> -->

<!-- version 2 code -->

<!-- <!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>KNN Prediction Form</title>
    <link rel="stylesheet" href="../static/index.css" />
    <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
  </head>
  <body>
    <div
      id="section3"
      class="section section-custom-form section-custom-kmeans"
      style="display: flex; flex-direction: column; align-items: center"
    >
      <a
        style="
          text-decoration: none;
          color: #fefefe;
          font-size: 20px;
          display: block;
          margin-left: 80%;
        "
        href="/"
        >Back</a
      >
      <div class="container1">
        <h1>KNN</h1>
        <form id="phoneForm">
          <label for="Brand">Brand:</label>
          <input type="text" id="Brand" name="Brand" required />
          <label for="Price">Price:</label>
          <input type="number" id="Price" name="Price" required />
          <label for="Internal storage (GB)">Internal Storage (GB):</label>
          <input
            type="number"
            id="Internal storage (GB)"
            name="Internal storage (GB)"
            required
          />
          <label for="RAM (GB)">RAM (GB):</label>
          <input type="number" id="RAM (GB)" name="RAM (GB)" required />
          <label for="Rear camera">Rear Camera (MP):</label>
          <input type="number" id="Rear camera" name="Rear camera" required />
          <label for="Front camera">Front Camera (MP):</label>
          <input type="number" id="Front camera" name="Front camera" required />
          <label for="Battery capacity (mAh)">Battery Capacity (mAh):</label>
          <input
            type="number"
            id="Battery capacity (mAh)"
            name="Battery capacity (mAh)"
            required
          />
          <button type="submit">Recommend</button>
        </form>
        <div id="loading" class="loading-spinner" style="display: none"></div>
        <div id="result"></div>
        <div id="phoneDetails"></div>
        <canvas id="comparisonRadarChart" style="display: none"></canvas>
        <canvas id="comparisonBarChart" style="display: none"></canvas>
        <canvas id="comparisonLineChart" style="display: none"></canvas>
      </div>
    </div>

    <script>
      let radarChart;
      let barChart;
      let lineChart;

      document
        .getElementById("phoneForm")
        .addEventListener("submit", function (event) {
          event.preventDefault();
          document.getElementById("loading").style.display = "block";
          document.getElementById("result").style.display = "none";
          document.getElementById("phoneDetails").style.display = "none";
          document.getElementById("comparisonRadarChart").style.display =
            "none";
          document.getElementById("comparisonBarChart").style.display = "none";
          document.getElementById("comparisonLineChart").style.display = "none";

          var form = document.getElementById("phoneForm");
          var formData = new FormData(form);

          var xhr = new XMLHttpRequest();
          xhr.open("POST", "/knn_predict", true);
          xhr.onload = function () {
            document.getElementById("loading").style.display = "none";
            if (xhr.status === 200) {
              var response = JSON.parse(xhr.responseText);
              document.getElementById("result").innerHTML =
                "<h3>Recommended Phone: " + response.prediction + "</h3>";
              document.getElementById("result").style.display = "block";

              var details = response.phone_details;
              var detailsHtml = "<h4>Phone Details:</h4><table>";
              for (var key in details) {
                detailsHtml +=
                  "<tr><td>" + key + "</td><td>" + details[key] + "</td></tr>";
              }
              detailsHtml += "</table>";
              document.getElementById("phoneDetails").innerHTML = detailsHtml;
              document.getElementById("phoneDetails").style.display = "block";

              var userValues = [
                parseFloat(document.getElementById("Price").value),
                parseFloat(
                  document.getElementById("Internal storage (GB)").value
                ),
                parseFloat(document.getElementById("RAM (GB)").value),
                parseFloat(document.getElementById("Rear camera").value),
                parseFloat(document.getElementById("Front camera").value),
                parseFloat(
                  document.getElementById("Battery capacity (mAh)").value
                ),
              ];

              var modelValues = [
                response.phone_details.Price,
                response.phone_details["Internal storage (GB)"],
                response.phone_details["RAM (GB)"],
                response.phone_details["Rear camera"],
                response.phone_details["Front camera"],
                response.phone_details["Battery capacity (mAh)"],
              ];

              var maxValues = [100000, 512, 12, 102, 48, 6000];

              var userPercentages = userValues.map(
                (val, i) => (val / maxValues[i]) * 100
              );
              var modelPercentages = modelValues.map(
                (val, i) => (val / maxValues[i]) * 100
              );

              if (radarChart) {
                radarChart.destroy();
              }
              if (barChart) {
                barChart.destroy();
              }
              if (lineChart) {
                lineChart.destroy();
              }

              var radarCtx = document
                .getElementById("comparisonRadarChart")
                .getContext("2d");
              document.getElementById("comparisonRadarChart").style.display =
                "block";
              radarChart = new Chart(radarCtx, {
                type: "radar",
                data: {
                  labels: [
                    "Price",
                    "Internal storage (GB)",
                    "RAM (GB)",
                    "Rear camera",
                    "Front camera",
                    "Battery capacity (mAh)",
                  ],
                  datasets: [
                    {
                      label: "User Input",
                      data: userPercentages,
                      backgroundColor: "rgba(75, 192, 192, 0.2)",
                      borderColor: "rgba(75, 192, 192, 1)",
                      borderWidth: 1,
                    },
                    {
                      label: "Recommended Phone",
                      data: modelPercentages,
                      backgroundColor: "rgba(153, 102, 255, 0.2)",
                      borderColor: "rgba(153, 102, 255, 1)",
                      borderWidth: 1,
                    },
                  ],
                },
                options: {
                  responsive: true,
                  scales: {
                    r: {
                      beginAtZero: true,
                      max: 100,
                      grid: {
                        color: "rgba(0, 0, 0, 0.2)",
                      },
                    },
                  },
                },
              });

              var barCtx = document
                .getElementById("comparisonBarChart")
                .getContext("2d");
              document.getElementById("comparisonBarChart").style.display =
                "block";
              barChart = new Chart(barCtx, {
                type: "bar",
                data: {
                  labels: [
                    "Price",
                    "Internal storage (GB)",
                    "RAM (GB)",
                    "Rear camera",
                    "Front camera",
                    "Battery capacity (mAh)",
                  ],
                  datasets: [
                    {
                      label: "User Input",
                      data: userPercentages,
                      backgroundColor: "rgba(75, 192, 192, 0.2)",
                      borderColor: "rgba(75, 192, 192, 1)",
                      borderWidth: 1,
                    },
                    {
                      label: "Recommended Phone",
                      data: modelPercentages,
                      backgroundColor: "rgba(153, 102, 255, 0.2)",
                      borderColor: "rgba(153, 102, 255, 1)",
                      borderWidth: 1,
                    },
                  ],
                },
                options: {
                  responsive: true,
                  scales: {
                    y: {
                      beginAtZero: true,
                      max: 100,
                      grid: {
                        color: "rgba(0, 0, 0, 0.2)",
                      },
                      ticks: {
                        callback: function (value) {
                          return value + "%";
                        },
                      },
                    },
                  },
                },
              });

              var lineCtx = document
                .getElementById("comparisonLineChart")
                .getContext("2d");
              document.getElementById("comparisonLineChart").style.display =
                "block";
              lineChart = new Chart(lineCtx, {
                type: "line",
                data: {
                  labels: [
                    "Price",
                    "Internal storage (GB)",
                    "RAM (GB)",
                    "Rear camera",
                    "Front camera",
                    "Battery capacity (mAh)",
                  ],
                  datasets: [
                    {
                      label: "User Input",
                      data: userPercentages,
                      backgroundColor: "rgba(75, 192, 192, 0.2)",
                      borderColor: "rgba(75, 192, 192, 1)",
                      borderWidth: 1,
                      fill: false,
                      tension: 0.1,
                    },
                    {
                      label: "Recommended Phone",
                      data: modelPercentages,
                      backgroundColor: "rgba(153, 102, 255, 0.2)",
                      borderColor: "rgba(153, 102, 255, 1)",
                      borderWidth: 1,
                      fill: false,
                      tension: 0.1,
                    },
                  ],
                },
                options: {
                  responsive: true,
                  scales: {
                    y: {
                      beginAtZero: true,
                      max: 100,
                      grid: {
                        color: "rgba(0, 0, 0, 0.2)",
                      },
                      ticks: {
                        callback: function (value) {
                          return value + "%";
                        },
                      },
                    },
                  },
                },
              });
            } else {
              document.getElementById("result").innerHTML =
                "Error: " + xhr.responseText;
              document.getElementById("result").style.display = "block";
            }
          };
          xhr.send(formData);
        });
    </script>
  </body>
</html> -->

<!-- version 3 code -->

<!-- <!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>KNN Prediction Form</title>
    <link rel="stylesheet" href="../static/index.css" />
    <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
  </head>
  <body>
    <div
      id="section3"
      class="section section-custom-form section-custom-kmeans"
      style="display: flex; flex-direction: column; align-items: center"
    >
      <a
        style="
          text-decoration: none;
          color: #fefefe;
          font-size: 20px;
          display: block;
          margin-left: 80%;
        "
        href="/"
        >Back</a
      >
      <div class="container1">
        <h1>KNN</h1>
        <form id="phoneForm">
          <label for="Brand">Brand:</label>
          <input type="text" id="Brand" name="Brand" required />
          <label for="Price">Price:</label>
          <input type="number" id="Price" name="Price" required />
          <label for="Internal storage (GB)">Internal Storage (GB):</label>
          <input
            type="number"
            id="Internal storage (GB)"
            name="Internal storage (GB)"
            required
          />
          <label for="RAM (GB)">RAM (GB):</label>
          <input type="number" id="RAM (GB)" name="RAM (GB)" required />
          <label for="Rear camera">Rear Camera (MP):</label>
          <input type="number" id="Rear camera" name="Rear camera" required />
          <label for="Front camera">Front Camera (MP):</label>
          <input type="number" id="Front camera" name="Front camera" required />
          <label for="Battery capacity (mAh)">Battery Capacity (mAh):</label>
          <input
            type="number"
            id="Battery capacity (mAh)"
            name="Battery capacity (mAh)"
            required
          />
          <button type="submit">Recommend</button>
        </form>
        <div id="loading" class="loading-spinner" style="display: none"></div>
        <div id="result"></div>
        <div id="phoneDetails"></div>
        <canvas id="comparisonRadarChart" style="display: none"></canvas>
        <canvas id="comparisonBarChart" style="display: none"></canvas>
        <canvas id="comparisonLineChart" style="display: none"></canvas>
      </div>
    </div>

    <script>
      let radarChart;
      let barChart;
      let lineChart;

      document
        .getElementById("phoneForm")
        .addEventListener("submit", function (event) {
          event.preventDefault();
          document.getElementById("loading").style.display = "block";
          document.getElementById("result").style.display = "none";
          document.getElementById("phoneDetails").style.display = "none";
          document.getElementById("comparisonRadarChart").style.display =
            "none";
          document.getElementById("comparisonBarChart").style.display = "none";
          document.getElementById("comparisonLineChart").style.display = "none";

          var form = document.getElementById("phoneForm");
          var formData = new FormData(form);

          var xhr = new XMLHttpRequest();
          xhr.open("POST", "/knn_predict", true);
          xhr.onload = function () {
            document.getElementById("loading").style.display = "none";
            if (xhr.status === 200) {
              var response = JSON.parse(xhr.responseText);
              document.getElementById("result").innerHTML =
                "<h3>Recommended Phone: " + response.prediction + "</h3>";
              document.getElementById("result").style.display = "block";

              var details = response.phone_details;
              var detailsHtml = "<h4>Phone Details:</h4><table>";
              for (var key in details) {
                detailsHtml +=
                  "<tr><td>" + key + "</td><td>" + details[key] + "</td></tr>";
              }
              detailsHtml += "</table>";
              document.getElementById("phoneDetails").innerHTML = detailsHtml;
              document.getElementById("phoneDetails").style.display = "block";

              var userValues = [
                parseFloat(document.getElementById("Price").value),
                parseFloat(
                  document.getElementById("Internal storage (GB)").value
                ),
                parseFloat(document.getElementById("RAM (GB)").value),
                parseFloat(document.getElementById("Rear camera").value),
                parseFloat(document.getElementById("Front camera").value),
                parseFloat(
                  document.getElementById("Battery capacity (mAh)").value
                ),
              ];

              var modelValues = [
                response.phone_details.Price,
                response.phone_details["Internal storage (GB)"],
                response.phone_details["RAM (GB)"],
                response.phone_details["Rear camera"],
                response.phone_details["Front camera"],
                response.phone_details["Battery capacity (mAh)"],
              ];

              var maxValues = [100000, 512, 12, 102, 48, 6000];

              var userPercentages = userValues.map(
                (val, i) => (val / maxValues[i]) * 100
              );
              var modelPercentages = modelValues.map(
                (val, i) => (val / maxValues[i]) * 100
              );

              if (radarChart) {
                radarChart.destroy();
              }
              if (barChart) {
                barChart.destroy();
              }
              if (lineChart) {
                lineChart.destroy();
              }

              var radarCtx = document
                .getElementById("comparisonRadarChart")
                .getContext("2d");
              document.getElementById("comparisonRadarChart").style.display =
                "block";
              radarChart = new Chart(radarCtx, {
                type: "radar",
                data: {
                  labels: [
                    "Price",
                    "Internal storage (GB)",
                    "RAM (GB)",
                    "Rear camera",
                    "Front camera",
                    "Battery capacity (mAh)",
                  ],
                  datasets: [
                    {
                      label: "User Input",
                      data: userPercentages,
                      backgroundColor: "rgba(75, 192, 192, 0.2)",
                      borderColor: "rgba(75, 192, 192, 1)",
                      borderWidth: 1,
                    },
                    {
                      label: "Recommended Phone",
                      data: modelPercentages,
                      backgroundColor: "rgba(153, 102, 255, 0.2)",
                      borderColor: "rgba(153, 102, 255, 1)",
                      borderWidth: 1,
                    },
                  ],
                },
                options: {
                  responsive: true,
                  scales: {
                    r: {
                      beginAtZero: true,
                      max: 100,
                      grid: {
                        color: "rgba(0, 0, 0, 0.2)",
                      },
                    },
                  },
                },
              });

              var barCtx = document
                .getElementById("comparisonBarChart")
                .getContext("2d");
              document.getElementById("comparisonBarChart").style.display =
                "block";
              barChart = new Chart(barCtx, {
                type: "bar",
                data: {
                  labels: [
                    "Price",
                    "Internal storage (GB)",
                    "RAM (GB)",
                    "Rear camera",
                    "Front camera",
                    "Battery capacity (mAh)",
                  ],
                  datasets: [
                    {
                      label: "User Input",
                      data: userPercentages,
                      backgroundColor: "rgba(75, 192, 192, 0.2)",
                      borderColor: "rgba(75, 192, 192, 1)",
                      borderWidth: 1,
                    },
                    {
                      label: "Recommended Phone",
                      data: modelPercentages,
                      backgroundColor: "rgba(153, 102, 255, 0.2)",
                      borderColor: "rgba(153, 102, 255, 1)",
                      borderWidth: 1,
                    },
                  ],
                },
                options: {
                  responsive: true,
                  scales: {
                    y: {
                      beginAtZero: true,
                      max: 100,
                      grid: {
                        color: "rgba(0, 0, 0, 0.2)",
                      },
                      ticks: {
                        callback: function (value) {
                          return value + "%";
                        },
                      },
                    },
                  },
                },
              });

              var lineCtx = document
                .getElementById("comparisonLineChart")
                .getContext("2d");
              document.getElementById("comparisonLineChart").style.display =
                "block";
              lineChart = new Chart(lineCtx, {
                type: "line",
                data: {
                  labels: [
                    "Price",
                    "Internal storage (GB)",
                    "RAM (GB)",
                    "Rear camera",
                    "Front camera",
                    "Battery capacity (mAh)",
                  ],
                  datasets: [
                    {
                      label: "User Input",
                      data: userPercentages,
                      backgroundColor: "rgba(75, 192, 192, 0.2)",
                      borderColor: "rgba(75, 192, 192, 1)",
                      borderWidth: 1,
                      fill: false,
                      tension: 0.1,
                    },
                    {
                      label: "Recommended Phone",
                      data: modelPercentages,
                      backgroundColor: "rgba(153, 102, 255, 0.2)",
                      borderColor: "rgba(153, 102, 255, 1)",
                      borderWidth: 1,
                      fill: false,
                      tension: 0.1,
                    },
                  ],
                },
                options: {
                  responsive: true,
                  scales: {
                    y: {
                      beginAtZero: true,
                      max: 100,
                      grid: {
                        color: "rgba(0, 0, 0, 0.2)",
                      },
                      ticks: {
                        callback: function (value) {
                          return value + "%";
                        },
                      },
                    },
                  },
                },
              });
            } else {
              document.getElementById("result").innerHTML =
                "Error: " + xhr.responseText;
              document.getElementById("result").style.display = "block";
            }
          };
          xhr.send(formData);
        });
    </script>
  </body>
</html> -->

<!-- version 4 -->

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>KNN Prediction Form</title>
    <link rel="stylesheet" href="../static/index.css" />
    <script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
  </head>
  <body>
    <!-- <div
      id="section3"
      class="section section-custom-form section-custom-kmeans"
      style="display: flex; flex-direction: column; align-items: center"
    >
      <a
        style="
          text-decoration: none;
          color: #fefefe;
          font-size: 20px;
          display: block;
          margin-left: 80%;
        "
        href="/"
        >Back</a
      >
      <div class="container1">
        <h1>KNN</h1>
        <form id="phoneForm">
          <label for="Brand">Brand:</label>
          <input type="text" id="Brand" name="Brand" required />
          <label for="Price">Price:</label>
          <input type="number" id="Price" name="Price" required />
          <label for="Internal storage (GB)">Internal Storage (GB):</label>
          <input
            type="number"
            id="Internal storage (GB)"
            name="Internal storage (GB)"
            required
          />
          <label for="RAM (GB)">RAM (GB):</label>
          <input type="number" id="RAM (GB)" name="RAM (GB)" required />
          <label for="Rear camera">Rear Camera (MP):</label>
          <input type="number" id="Rear camera" name="Rear camera" required />
          <label for="Front camera">Front Camera (MP):</label>
          <input type="number" id="Front camera" name="Front camera" required />
          <label for="Battery capacity (mAh)">Battery Capacity (mAh):</label>
          <input
            type="number"
            id="Battery capacity (mAh)"
            name="Battery capacity (mAh)"
            required
          />
          <button type="submit">Recommend</button>
        </form>
        <div id="loading" class="loading-spinner" style="display: none"></div>
        <div id="result"></div>
        <div id="phoneDetails"></div>
        <canvas id="comparisonRadarChart" style="display: none"></canvas>
        <canvas id="comparisonBarChart" style="display: none"></canvas>
        <canvas id="comparisonLineChart" style="display: none"></canvas>
      </div>
    </div>

    <script>
      let radarChart;
      let barChart;
      let lineChart;

      document
        .getElementById("phoneForm")
        .addEventListener("submit", function (event) {
          event.preventDefault();
          document.getElementById("loading").style.display = "block";
          document.getElementById("result").style.display = "none";
          document.getElementById("phoneDetails").style.display = "none";
          document.getElementById("comparisonRadarChart").style.display =
            "none";
          document.getElementById("comparisonBarChart").style.display = "none";
          document.getElementById("comparisonLineChart").style.display = "none";

          var form = document.getElementById("phoneForm");
          var formData = new FormData(form);

          var xhr = new XMLHttpRequest();
          xhr.open("POST", "/knn_predict", true);
          xhr.onload = function () {
            document.getElementById("loading").style.display = "none";
            if (xhr.status === 200) {
              var response = JSON.parse(xhr.responseText);
              var resultHtml = "<h3>Recommended Phones:</h3><ul>";
              response.predictions.forEach(function (phone) {
                resultHtml += "<li>" + phone.name + "</li>";
                var details = phone.details;
                var detailsHtml =
                  "<h4>Details for " + phone.name + ":</h4><table>";
                for (var key in details) {
                  detailsHtml +=
                    "<tr><td>" +
                    key +
                    "</td><td>" +
                    details[key] +
                    "</td></tr>";
                }
                detailsHtml += "</table>";
                document.getElementById("phoneDetails").innerHTML +=
                  detailsHtml;
              });
              resultHtml += "</ul>";
              document.getElementById("result").innerHTML = resultHtml;
              document.getElementById("result").style.display = "block";
              document.getElementById("phoneDetails").style.display = "block";
            } else {
              document.getElementById("result").innerHTML =
                "An error occurred. Please try again.";
              document.getElementById("result").style.display = "block";
            }
          };
          xhr.send(formData);
        });
    </script> -->

    <div
      id="section3"
      class="section section-custom-form"
      style="display: flex; flex-direction: column; align-items: center"
    >
      <a
        style="
          text-decoration: none;
          color: #fefefe;
          font-size: 20px;
          display: block;
          margin-left: 80%;
        "
        href="/"
        >Back</a
      >

      <div class="container1">
        <h3>KNN</h3>
        <form id="phoneForm">
          <label for="Brand">Brand:</label>
          <input type="text" id="Brand" name="Brand" required />
          <label for="Price">Price:</label>
          <input type="number" id="Price" name="Price" required />
          <label for="Internal storage (GB)">Internal Storage (GB):</label>
          <input
            type="number"
            id="Internal storage (GB)"
            name="Internal storage (GB)"
            required
          />
          <label for="RAM (GB)">RAM (GB):</label>
          <input type="number" id="RAM (GB)" name="RAM (GB)" required />
          <label for="Rear camera">Rear Camera (MP):</label>
          <input type="number" id="Rear camera" name="Rear camera" required />
          <label for="Front camera">Front Camera (MP):</label>
          <input type="number" id="Front camera" name="Front camera" required />
          <label for="Battery capacity (mAh)">Battery Capacity (mAh):</label>
          <input
            type="number"
            id="Battery capacity (mAh)"
            name="Battery capacity (mAh)"
            required
          />
          <button type="submit">Recommend</button>
        </form>
        <div id="result"></div>
        <div id="phoneDetails"></div>
        <canvas id="comparisonRadarChart" style="display: none"></canvas>
        <canvas id="comparisonBarChart" style="display: none"></canvas>
        <canvas id="comparisonLineChart" style="display: none"></canvas>
      </div>
    </div>

    <div id="myModal" class="modal">
      <div class="modal-content">
        <span class="close">&times;</span>
        <h3 id="modal-title"></h3>
      </div>
    </div>

    <script>
      document.addEventListener("DOMContentLoaded", function () {
        let sections = document.querySelectorAll(".section");
        let currentSection = 0;
        let isScrolling = false;

        window.addEventListener("wheel", function (event) {
          event.preventDefault();
          if (isScrolling) return;
          isScrolling = true;
          setTimeout(function () {
            isScrolling = false;
          }, 1000);

          if (event.deltaY > 0) {
            currentSection++;
          } else {
            currentSection--;
          }
          if (currentSection < 0) {
            currentSection = 0;
          } else if (currentSection >= sections.length) {
            currentSection = sections.length - 1;
          }
          sections[currentSection].scrollIntoView({ behavior: "smooth" });
        });

        document
          .querySelector(".start-button")
          .addEventListener("click", function (event) {
            event.preventDefault();
            document
              .getElementById("section2")
              .scrollIntoView({ behavior: "smooth" });
          });

        document
          .querySelector(".try-other-models-btn")
          .addEventListener("click", function () {
            // Scroll to the next section
            currentSection++;
            if (currentSection >= sections.length) {
              currentSection = sections.length - 1;
            }
            sections[currentSection].scrollIntoView({ behavior: "smooth" });
          });
      });
    </script>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script>
      let radarChart;
      let barChart;
      let lineChart;

      $(document).ready(function () {
        $("#phoneForm").on("submit", function (e) {
          e.preventDefault();
          $.ajax({
            url: "/knn_predict",
            type: "POST",
            data: $("#phoneForm").serialize(),
            success: function (response) {
              $("#result").html(
                "<h3>Recommended Phone: " + response.prediction + "</h3>"
              );

              // Display phone details
              const details = response.phone_details;
              let detailsHtml = "<h4>Phone Details:</h4><table>";
              for (const key in details) {
                detailsHtml +=
                  "<tr><td>" + key + "</td><td>" + details[key] + "</td></tr>";
              }
              detailsHtml += "</table>";
              $("#phoneDetails").html(detailsHtml).fadeIn();

              // Fetch and display the comparison chart
              const formData = $("#phoneForm").serializeArray();
              const formObj = {};
              formData.forEach((item) => (formObj[item.name] = item.value));

              fetch("/stats", {
                method: "POST",
                headers: {
                  "Content-Type": "application/json",
                },
                body: JSON.stringify(formObj),
              })
                .then((response) => response.json())
                .then((data) => {
                  const userValues = [
                    data.user_input.Price,
                    data.user_input["Internal storage (GB)"],
                    data.user_input["RAM (GB)"],
                    data.user_input["Rear camera"],
                    data.user_input["Front camera"],
                    data.user_input["Battery capacity (mAh)"],
                  ];

                  const modelValues = [
                    data.model_output_stats.Price,
                    data.model_output_stats["Internal storage (GB)"],
                    data.model_output_stats["RAM (GB)"],
                    data.model_output_stats["Rear camera"],
                    data.model_output_stats["Front camera"],
                    data.model_output_stats["Battery capacity (mAh)"],
                  ];

                  // Convert to percentages for scaling
                  const maxValues = [
                    100000, // Example max value for Price
                    512, // Max Internal storage (GB)
                    12, // Max RAM (GB)
                    102, // Max Rear camera (MP)
                    48, // Max Front camera (MP)
                    6000, // Max Battery capacity (mAh)
                  ];

                  const userPercentages = userValues.map(
                    (val, i) => (val / maxValues[i]) * 100
                  );
                  const modelPercentages = modelValues.map(
                    (val, i) => (val / maxValues[i]) * 100
                  );

                  // Destroy previous charts if they exist
                  if (radarChart) {
                    radarChart.destroy();
                  }
                  if (barChart) {
                    barChart.destroy();
                  }
                  if (lineChart) {
                    lineChart.destroy();
                  }

                  const labels = [
                    "Price",
                    "Internal storage (GB)",
                    "RAM (GB)",
                    "Rear camera",
                    "Front camera",
                    "Battery capacity (mAh)",
                  ];

                  const radarCtx = document
                    .getElementById("comparisonRadarChart")
                    .getContext("2d");
                  radarChart = new Chart(radarCtx, {
                    type: "radar",
                    data: {
                      labels: labels,
                      datasets: [
                        {
                          label: "Your Input",
                          data: userPercentages,
                          backgroundColor: "rgba(255, 99, 132, 0.2)",
                          borderColor: "rgba(255, 99, 132, 1)",
                          borderWidth: 1,
                        },
                        {
                          label: "Recommended Phone",
                          data: modelPercentages,
                          backgroundColor: "rgba(54, 162, 235, 0.2)",
                          borderColor: "rgba(54, 162, 235, 1)",
                          borderWidth: 1,
                        },
                      ],
                    },
                    options: {
                      scales: {
                        r: {
                          suggestedMin: 0,
                          suggestedMax: 100,
                        },
                      },
                    },
                  });

                  document.getElementById(
                    "comparisonRadarChart"
                  ).style.display = "block";

                  const barCtx = document
                    .getElementById("comparisonBarChart")
                    .getContext("2d");
                  barChart = new Chart(barCtx, {
                    type: "bar",
                    data: {
                      labels: labels,
                      datasets: [
                        {
                          label: "Your Input",
                          data: userValues,
                          backgroundColor: "rgba(255, 99, 132, 0.2)",
                          borderColor: "rgba(255, 99, 132, 1)",
                          borderWidth: 1,
                        },
                        {
                          label: "Recommended Phone",
                          data: modelValues,
                          backgroundColor: "rgba(54, 162, 235, 0.2)",
                          borderColor: "rgba(54, 162, 235, 1)",
                          borderWidth: 1,
                        },
                      ],
                    },
                    options: {
                      scales: {
                        y: {
                          beginAtZero: true,
                        },
                      },
                    },
                  });

                  document.getElementById("comparisonBarChart").style.display =
                    "block";

                  const lineCtx = document
                    .getElementById("comparisonLineChart")
                    .getContext("2d");
                  lineChart = new Chart(lineCtx, {
                    type: "line",
                    data: {
                      labels: labels,
                      datasets: [
                        {
                          label: "Your Input",
                          data: userValues,
                          backgroundColor: "rgba(255, 99, 132, 0.2)",
                          borderColor: "rgba(255, 99, 132, 1)",
                          borderWidth: 1,
                          fill: false,
                        },
                        {
                          label: "Recommended Phone",
                          data: modelValues,
                          backgroundColor: "rgba(54, 162, 235, 0.2)",
                          borderColor: "rgba(54, 162, 235, 1)",
                          borderWidth: 1,
                          fill: false,
                        },
                      ],
                    },
                    options: {
                      scales: {
                        y: {
                          beginAtZero: true,
                        },
                      },
                    },
                  });

                  document.getElementById("comparisonLineChart").style.display =
                    "block";
                });
            },
            error: function (error) {
              $("#result").html(
                "<h3>An error occurred. Please try again.</h3>"
              );
            },
          });
        });
      });
    </script>
  </body>
</html>
